
package org.omegahat.DataStructures.Data;

import java.io.StreamTokenizer;

/**
  Implementation class for the different classes of variables
  that provides the outer loop for reading values from a stream.
*/
abstract public class AbstractVariable  {
public Object value(long i) {
  return(value((int)i));
}

abstract Object value(int i);


/**
 Read tokens from the input reader, in the sense of the class
 <FONT CLASS=JavaClass>java.io.StreamTokenizer</FONT>.<p>
Following the sense of that class, tokens are either numbers or words (ends of line are
ignored).  The corresponding <FONT CLASS=JavaMethod>add()</FONT> method is called
using the numeric or string value field of the tokenizer.
*/
public int read(java.io.Reader reader) 
   throws java.io.IOException
{
  java.io.StreamTokenizer tokenizer = new java.io.StreamTokenizer(reader);

  int ctr = 0;
  while( tokenizer.nextToken() != StreamTokenizer.TT_EOF) {
   switch(tokenizer.ttype) {
      case StreamTokenizer.TT_NUMBER:
        add(tokenizer.nval, -1);
      break;
      case StreamTokenizer.TT_WORD:
        add(tokenizer.sval, -1);
      break;
   }

   ctr++;
  }

 return(ctr);
}
abstract public void add(double value, int which);
abstract public void add(Object value, int which);

/**
 Stores the name-value properties for this variable
 for entries such as a description string, anomalies
 missing value codes, etc. that are interpreted by
 different "readers"
*/
protected java.util.Hashtable metaData;

protected String name;

/**
   Accessor for {@link #metaData metaData} field
 */
public java.util.Hashtable metaData()
{
   return(metaData);
}

/**
   Accessor for setting {@link #metaData metaData} field
 */

public java.util.Hashtable metaData(java.util.Hashtable value)
{
   metaData = value;
  return(metaData);
}


public String getName() {
 return(name);
}

public String setName(String val) {
  name = val;
 return(getName());
}



public VariableInt values(SelectorInt selector) {
  return(values(selector.toArray()));
}

public abstract VariableInt values(int[] which);
}

